# -*- coding: utf-8 -*-
"""
Created on Fri May 29 00:29:42 2020

@author: rvillaco
"""
from tweepy.streaming import StreamListener
from tweepy import Stream, OAuthHandler
from datetime import datetime
import time, json

class listener(StreamListener):
    ''' This class streams tweets saving different files for each day of the steram'''
    def __init__(self, path,fileName,StartDate):
        self.fileName=r'{0}\{1}'.format(path,fileName)
        self.start_date=StartDate        
        self.base_file=open(r'{0}_{1}.json'.format(self.fileName,self.start_date),'a+',encoding="utf8")
    def on_data(self, raw_data):
        today=datetime.now().strftime("%Y-%m-%d")
        if today!=self.start_date:
            self.start_date=datetime.now().strftime("%Y-%m-%d")
            self.base_file.close()
            fName=r'{0}_{1}.json'.format(self.fileName,self.start_date)
            self.base_file=open(fName,'a+',encoding="utf8")
            print('Day expired, now writing in file: ' + fName)
        data = json.loads(raw_data)    
        self.base_file.write(json.dumps(data) + '\n')
        return True

def fetch(query,outPath,fileName,ckey,csecret,atoken,asecret,max_daily_errors=5):
    auth = OAuthHandler(ckey, csecret)
    auth.set_access_token(atoken, asecret)
    startDate=datetime.now().strftime("%Y-%m-%d")
    error_per_day=0
    timeOfFirstError=None
    while True:
        try:
            print('Starting Stream')
            sListenter=listener(outPath,fileName,startDate)
            twitterStream = Stream(auth, sListenter, tweet_mode= 'extended')
            twitterStream.filter(track=query)
        except:
            if error_per_day == 0:
                error_per_day += 1
                timeOfFirstError=datetime.now()
                print('Error #'+str(error_per_day)+' Waiting for ' +str(60*error_per_day^2)+' seconds')
                time.sleep(60*error_per_day^2)
                continue                
            elif error_per_day < max_daily_errors:
                daysSinceError=(datetime.now()-timeOfFirstError).days
                error_per_day+=1
                if daysSinceError==0:
                    print('Error #'+str(error_per_day)+' Waiting for ' +str(60*error_per_day^2)+' seconds')
                    time.sleep(60*error_per_day^2)
                    continue
                else:
                    error_per_day=1
                    timeOfFirstError=datetime.now()
                    print('Error #'+str(error_per_day)+' Waiting for ' +str(60*error_per_day^2)+' seconds')
                    time.sleep(60*error_per_day^2)
                    continue
            else:
                print(f'{max_daily_errors} in the same day, breaking stream')
                sListenter.base_file.close()
                break

   
# Replace following parameters    
outPath = '.'
query_list = ['coronavirus hoax']
fName = 'coronavirus'
ckey = ''
csecret = '' 
atoken = ''
asecret = ''

# Stream Tweets
fetch(query_list,outPath,fName,ckey,csecret,atoken,asecret)